'****************************************************************
'*  Name    : JOYSTICK.PBP                                      *
'*  Author  : Scumari                                           *
'*  Notice  : Copyright (c) 2010 SCUMARI TECHNOLOGIES           *
'*          : All Rights Reserved                               *
'*  Date    : november 2010                                     *
'*  Version : 1.0                                               *
'*  Notes   :  Polling interval changed to 100ms from 40 ms     *
'*          :                                                   *
'****************************************************************
'                         PIC18F4550
'                          ___ ___
'           MCLR/VPP/RE3 o|1  _ 40|o RB7/KBI3/PGD
'                RA0/AN0 o|2    39|o RB6/KBI2/PGC
'                RA1/AN1 o|3    38|o RB5/KBI1/PGM
'    RA2/AN2/VREF-/CVREF o|4    37|o RB4/AN11/KBI0/CSSPP
'          RA3/AN3/VREF+ o|5    36|o RB3/AN9/CCP2(1)/VPO
'    RA4/T0CKI/C1OUT/RCV o|6    35|o RB2/AN8/INT2/VMO
'RA5/AN4/SS/HLVDIN/C2OUT o|7    34|o RB1/AN10/INT1/SCK/SCL
'         RE0/AN5/CK1SPP o|8    33|o RB0/AN12/INT0/FLT0/SDI/SDA
'         RE1/AN6/CK2SPP o|9    32|o VDD
'          RE2/AN7/OESPP o|10   31|o VSS
'                    VDD o|11   30|o RD7/SPP7/P1D
'                    VSS o|12   29|o RD6/SPP6/P1C
'              OSC1/CLKI o|13   28|o RD5/SPP5/P1B
'          OSC2/CLKO/RA6 o|14   27|o RD4/SPP4
'       RC0/T1OSO/T13CKI o|15   26|o RC7/RX/DT/SDO
'  RC1/T1OSI/CCP2(1)/UOE o|16   25|o RC6/TX/CK
'           RC2/CCP1/P1A o|17   24|o RC5/D+/VP
'                   VUSB o|18   23|o RC4/D-/VM
'               RD0/SPP0 o|19   22|o RD3/SPP3
'               RD1/SPP1 o|20   21|o RD2/SPP2
'                          -------
'
'       DSBRUT
'               SCL SDA
'   VCC TX  RX  PC5 PC4 PD3 PD4 PD6 PD5 CND PC3
'   |o   o   o   o   o   o   o   o   o   o   o |
'   --------------------------------------------


	Include	"Js_hid_desc.bas"	' Include the HID descriptors
    'Include "modedefs.bas"  ' Include serial modes

    DEFINE OSC 48          
    DEFINE LOADER_USED 1
    DEFINE RESET_ORG 1100h ' For Microchip USB Bootloader
    DEFINE INTERRUPT_ORG 1108h ' For Microchip USB Bootloader     'LED var PORTC.0

    ' Define ADCIN parameters
    Define	ADC_BITS	    8	' Set number of bits in result
    Define	ADC_CLOCK	    3	' Set clock source (3=rc)
    Define	ADC_SAMPLEUS	50	' Set sampling time in uS

    USBBufferSizeMax   con 8  ' maximum buffer size
    USBBufferSizeTX    con 8  ' input 
    USBBufferSizeRX    con 8  ' output

    ' the USB buffer...
    USBBuffer        Var Byte[USBBufferSizeMax] 
    USBBufferCount   Var Byte
    temp             var byte 

' ************************************************************
' * Port configuration:                                      *
' * PORTD.0-7 are digital inputs                         *
' * AN0,AN5 active as analog inputs                          *
' ************************************************************

    PORTA = 0
    PORTB = 0
    PORTC = 0
    PORTD = 0
    PORTE = 0
    TRISA = %11111111
    TRISB = %11111111
    TRISC = %11111111
    TRISD = %11111111
    TRISE = %11111111

	ADCON1 = %00001010
    
    pause 500	

' ************************************************************
' * main program loop - remember, you must keep the USB      *
' * connection alive with a call to USBService every couple  *
' * of milliseconds or so...                                 *
' ************************************************************
    USBInit ' initialise USB...
ProgramStart: 
'   gosub DoUSBIn
    ADCIN 0,USBBuffer[0]
    ADCIN 1,USBBuffer[1]
    USBSERVICE
    ADCIN 2,USBBuffer[2]
    ADCIN 3,USBBuffer[3]
    ADCIN 4,USBBuffer[4]
    GoSub DoUSBOut                                    ' keep connection alive
    USBSERVICE
    
    USBBuffer.0(40) = 1    
    USBBuffer.0(41) = 1    
    USBBuffer.0(42) = 1    
    USBBuffer.0(43) = 1    

    USBSERVICE

    if PORTD.0 = 0 then
        USBBuffer.0(40) = 0    
        USBBuffer.0(41) = 0    
        USBBuffer.0(42) = 0    
        USBBuffer.0(43) = 0    
    endif

    if PORTD.1 = 0 then
        USBBuffer.0(41) = 0    
        USBBuffer.0(42) = 0    
        USBBuffer.0(43) = 0    
    endif

    if PORTD.2 = 0 then
        USBBuffer.0(40) = 0    
        USBBuffer.0(42) = 0    
        USBBuffer.0(43) = 0    
    endif

    if PORTD.3 = 0 then
        USBBuffer.0(42) = 0    
        USBBuffer.0(43) = 0    
    endif

    USBSERVICE

    temp = 255-PORTB
    USBBuffer.0(44) = temp.0
    USBBuffer.0(45) = temp.1
    USBBuffer.0(46) = temp.2
    USBBuffer.0(47) = temp.3
    USBBuffer.0(48) = temp.4
    USBBuffer.0(49) = temp.5
    USBBuffer.0(50) = temp.6
    USBBuffer.0(51) = temp.7

    USBSERVICE

    temp = 255-PORTD
    USBBuffer.0(52) = temp.7
    USBBuffer.0(53) = temp.6
    USBBuffer.0(54) = temp.5
    USBBuffer.0(55) = temp.4

    USBSERVICE

    temp = 255-PORTC
    USBBuffer.0(56) = temp.6
    USBBuffer.0(57) = temp.7
    USBBuffer.0(58) = temp.0
    USBBuffer.0(59) = temp.1
    USBBuffer.0(60) = temp.2

    USBSERVICE

    temp = 255-PORTE
    USBBuffer.0(61) = temp.2
    USBBuffer.0(62) = temp.1
    USBBuffer.0(63) = temp.0


DoUSBOut0:
   USBBufferCount = USBBufferSizeTX              ' TX buffer size
   USBService                                    ' keep connection alive
   USBOut 1, USBBuffer, USBBufferCount, DoUSBOut2 ' if bus available, transmit data
DoUSBOut2:
   GoTo ProgramStart  

' ************************************************************
' * receive data from the USB bus                            *
' ************************************************************
DoUSBIn:
   USBBufferCount = USBBufferSizeRX              ' RX buffer size
   USBService                                    ' keep connection alive
   USBIn 1, USBBuffer, USBBufferCount, DoUSBIn   ' read data, if available
   Return
    
' ************************************************************
' * wait for USB interface to attach                         *
' ************************************************************
DoUSBOut:
   USBBufferCount = USBBufferSizeTX              ' TX buffer size
   USBService                                    ' keep connection alive
   USBOut 1, USBBuffer, USBBufferCount, DoUSBOut1 ' if bus available, transmit data
DoUSBOut1:
   Return
   
   end
