'****************************************************************
'*  Name    : JoystickFY.bas                                    *
'*  Author  : Scumari                                           *
'*  Notice  : Copyright (c) 2016 SCUMARI TECHNOLOGIES           *
'*          : All Rights Reserved                               *
'*  Date    : november 2016                                     *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
'                             18F14K50
'                              ___ ___
'                       VDD  O|1  - 20|O  VSS
'            RA5 OSC1 OSCIN  O|2    19|O  RA0  D+   PGD
'           RA4 OSC2 CLKOUT  O|3    18|O  RA1  D-   PGC
'              RA3 MCLR VPP  O|4    17|O  VUSB
'         RC5 CCP P1A T0CKI  O|5    16|O  RC0  AN4  C12IN+  INT0    VREF+
'        RC4 P1B C12OUT SRQ  O|6    15|O  RC1  AN5  C12IN1- INT1    VREF-
'   RC3 AN7 P1C C12IN3- PGM  O|7    14|O  RC2  AN6  P1D     C12IN2- CVREF INT2
' RC6 AN8 SS  T13CKI T1OSCI  O|8    13|O  RB4  AN10 SDI     SDA
'        RC7 AN9 SDO T1OSCO  O|9    12|O  RB5  AN11 RX      DT
'                RB7 TX  CK  O|10   11|O  RB6  SCK  SCL
'                             ---------
'


	Include	"JsFY_desc.bas"	' Include the HID descriptors
    'Include "modedefs.bas"  ' Include serial modes

    DEFINE OSC 48          
    DEFINE LOADER_USED 1
    DEFINE RESET_ORG 1100h ' For Microchip USB Bootloader
    DEFINE INTERRUPT_ORG 1108h ' For Microchip USB Bootloader     'LED var PORTC.0

    'define HSER_RCSTA 090h
    'define HSER_TXSTA 0A4h  '16F = 020h  18F = 0A4h
    'define HSER_BAUD 19200
    'define HSER_CLROERR


    ' Define ADCIN parameters
    Define	ADC_BITS	    8	' Set number of bits in result
    Define	ADC_CLOCK	    3	' Set clock source (3=rc)
    Define	ADC_SAMPLEUS	100	' Set sampling time in uS

    USBBufferSizeMax   con 1  ' maximum buffer size
    USBBufferSizeTX    con 1  ' input 
    USBBufferSizeRX    con 1  ' output
    

    ' the USB buffer...
    USBBuffer        Var Byte[USBBufferSizeMax] 
    USBBufferCount   Var Byte
    temp             var byte 


    PORTA = 0
    PORTB = 0
    PORTC = 0
    TRISA = %11111111
    TRISB = %11111111
    TRISC = %11111111
    
    IOCA = 0
    IOCB = 0
    WPUA = 0
    WPUB = 0

	ANSEL = %00000000
    ANSELH= %00000000	

    USBInit ' initialise USB...
ProgramStart: 

    USBBuffer.0(0) = 1
    USBBuffer.0(1) = 1
    USBBuffer.0(2) = 1
    USBBuffer.0(3) = 1

    if PORTB = %11100000 then 
        USBBuffer.0(2) = 0
        USBBuffer.0(3) = 0
    endif
    if PORTB = %11010000 then 
        USBBuffer.0(0) = 0
        USBBuffer.0(2) = 0
        USBBuffer.0(3) = 0
    endif
    if PORTB = %10110000 then 
        USBBuffer.0(1) = 0
        USBBuffer.0(2) = 0
        USBBuffer.0(3) = 0
    endif
    USBSERVICE
    if PORTB = %01110000 then 
        USBBuffer.0(0) = 0
        USBBuffer.0(1) = 0
        USBBuffer.0(2) = 0
        USBBuffer.0(3) = 0
    endif
    
    temp = 255 - PORTC
    USBBuffer.0(4) = temp.1
    USBBuffer.0(5) = temp.0
    USBBuffer.0(6) = temp.4
    USBBuffer.0(7) = temp.2

    'hserout [dec USBBuffer[0]," ",dec USBBuffer[1],dec PORTC,13,10]
    'pause 1000
    
DoUSBOut0:
   USBBufferCount = USBBufferSizeTX              ' TX buffer size
   USBService                                    ' keep connection alive
   USBOut 1, USBBuffer, USBBufferCount, DoUSBOut0 ' if bus available, transmit data
DoUSBOut2:
   GoTo ProgramStart  

' ************************************************************
' * receive data from the USB bus                            *
' ************************************************************
DoUSBIn:
   USBBufferCount = USBBufferSizeRX              ' RX buffer size
   USBService                                    ' keep connection alive
   USBIn 1, USBBuffer, USBBufferCount, DoUSBIn1   ' read data, if available
DoUSBIn1:
   Return
    
' ************************************************************
' * wait for USB interface to attach                         *
' ************************************************************
DoUSBOut:
   USBBufferCount = USBBufferSizeTX              ' TX buffer size
   USBService                                    ' keep connection alive
   USBOut 1, USBBuffer, USBBufferCount, DoUSBOut1 ' if bus available, transmit data
DoUSBOut1:
   Return
   
   end
